#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>

void *emalloc(void *ptr, size_t size) {
	void *m = realloc(ptr,size);
	if (m == NULL) {
		fprintf(stderr,"error 255: malloc failed\n");
		exit(255);
	}
	return m;
}

char readline(char * buffer,int maxsize) {
	int index = 0;
	while (index < maxsize) {
		read(STDIN_FILENO,&buffer[index],sizeof(char));
		if (buffer[index] == '\n') {
			buffer[index] = 0;
			return 1;
		}
		index += 1;
	}
	
	char endbuffer;
	read(STDIN_FILENO,&endbuffer,sizeof(char));
	if (endbuffer == '\n') { return 1; }
	
	while (1) {
		read(STDIN_FILENO,&endbuffer,sizeof(char));
		if (endbuffer == '\n') { return 0; }
	}
}

int userUID; int userGID;
int ownerUID; int ownerGID;
// Inherit the privileges of the file owner, if setuid/setgid sticky bits are set.
void eowner(char sw) {
	if (sw == -1) { // Give up priveleges entirely (cannot be re-acquired)
		setgid(userGID);
		setreuid(userUID,userUID);
		return;
	}
	
	if (sw == 0) { // Uninherit priveleges (root privileges can still be acquired by this process and sub-processes, they're just not in effect)
		setgid(userGID);
		setreuid(userUID,ownerUID);
		return;
	}
	
	if (sw == 1) { // Acquire priveleges
		setgid(ownerGID);
		setreuid(ownerUID,ownerUID);
		return;
	}
	
	// printf("Real UID:      %d\n", getuid());
	// printf("Effective UID: %d\n", geteuid());
	// printf("Real GID:      %d\n", getgid());
}

int main(int argc, char **argv) {
	extern char **environ;
	environ = NULL; // Clear environment to boost security
	
	userUID = getuid();
	userGID = getgid();
	ownerUID = geteuid();
	ownerGID = getegid();
	eowner(0);
	
	// Menu
	char choice;
	char valid;
	while (1) {
		printf("1) Suspend Hybrid\n");
		printf("2) Suspend\n");
		printf("3) Hibernate\n");
		printf("4) Reboot\n");
		printf("5) Shutdown\n");
		printf("Choice: ");
		fflush(stdout);
		valid = readline(&choice,1);
		if (valid == 0) { goto loop; }
		choice -= 48; // ASCII to integer
		
		if ((choice > 0) && (choice < 6)) {
			break;
		}
		
		loop:
		printf("\n");
	}
	
	char **cmd;
	cmd = emalloc(NULL,1 * sizeof(char*)); // As of now, all cmds are just 1 char* long, but there might be more required somewhen.
	if (choice == 1) { cmd[0] = CMD_HYBRID; }
	if (choice == 2) { cmd[0] = CMD_SUSPEND; }
	if (choice == 3) { cmd[0] = CMD_HIBERNATE; }
	if (choice == 4) { cmd[0] = CMD_REBOOT; }
	if (choice == 5) { cmd[0] = CMD_POWEROFF; }
	
	// Run program
	eowner(1);
	int rtn = execv(cmd[0],cmd);
	eowner(-1);
	if (rtn == -1) {
		return 254 - errno;
	}
	return 0;
}
